#include <stdlib.h>
#include <stdio.h>
#include <dlfcn.h>

extern const char *libb_test() {
    return "I'm lib B";
}

extern const char *libb_dep() {
    void *handle;
    const char *(*func)();
    const char *ret;
    char *error;
    handle = dlopen("./liba.so", RTLD_LAZY);
    if (NULL == handle)
      return "load fail";
    func = dlsym(handle, "liba_test");
    if (NULL == func)  {
      dlclose(handle);
      return "func fail";
    }
    ret = (*func)();
    dlclose(handle);
    return ret;
}